//
// FacelistsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class FacelistsAPI {
    /**
     Add face to the list

     - parameter facelistId: (path)  
     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addFaceListFace(facelistId: Int, faceId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        addFaceListFaceWithRequestBuilder(facelistId: facelistId, faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add face to the list
     - POST /api/v1/facelists/{facelist_id}/faces/{face_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter facelistId: (path)  
     - parameter faceId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func addFaceListFaceWithRequestBuilder(facelistId: Int, faceId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/facelists/{facelist_id}/faces/{face_id}"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Create new face list

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createFaceList(body: FaceListCreate, completion: @escaping ((_ data: FaceListGet?,_ error: Error?) -> Void)) {
        createFaceListWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new face list
     - POST /api/v1/facelists

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "face_count" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low"
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<FaceListGet> 
     */
    open class func createFaceListWithRequestBuilder(body: FaceListCreate) -> RequestBuilder<FaceListGet> {
        let path = "/api/v1/facelists"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete specified face list

     - parameter facelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteFaceList(facelistId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteFaceListWithRequestBuilder(facelistId: facelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete specified face list
     - DELETE /api/v1/facelists/{facelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter facelistId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteFaceListWithRequestBuilder(facelistId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/facelists/{facelist_id}"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get face list with provided ID

     - parameter facelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFaceList(facelistId: Int, completion: @escaping ((_ data: FaceListGet?,_ error: Error?) -> Void)) {
        getFaceListWithRequestBuilder(facelistId: facelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get face list with provided ID
     - GET /api/v1/facelists/{facelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "face_count" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low"
}}]
     - parameter facelistId: (path)  

     - returns: RequestBuilder<FaceListGet> 
     */
    open class func getFaceListWithRequestBuilder(facelistId: Int) -> RequestBuilder<FaceListGet> {
        var path = "/api/v1/facelists/{facelist_id}"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get faces of the list

     - parameter facelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFaceListFaces(facelistId: Int, completion: @escaping ((_ data: FaceGetList?,_ error: Error?) -> Void)) {
        getFaceListFacesWithRequestBuilder(facelistId: facelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get faces of the list
     - GET /api/v1/facelists/{facelist_id}/faces

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "faces" : [ {
    "images" : [ {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    }, {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    } ],
    "full_name" : "full_name",
    "document_number" : "document_number",
    "sex" : "m",
    "birth_date" : "2000-01-23",
    "id" : 0
  }, {
    "images" : [ {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    }, {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    } ],
    "full_name" : "full_name",
    "document_number" : "document_number",
    "sex" : "m",
    "birth_date" : "2000-01-23",
    "id" : 0
  } ]
}}]
     - parameter facelistId: (path)  

     - returns: RequestBuilder<FaceGetList> 
     */
    open class func getFaceListFacesWithRequestBuilder(facelistId: Int) -> RequestBuilder<FaceGetList> {
        var path = "/api/v1/facelists/{facelist_id}/faces"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceGetList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get all face lists, optionally filtered by name

     - parameter name: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFaceLists(name: String? = nil, completion: @escaping ((_ data: FaceListList?,_ error: Error?) -> Void)) {
        getFaceListsWithRequestBuilder(name: name).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get all face lists, optionally filtered by name
     - GET /api/v1/facelists

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "facelists" : [ {
    "face_count" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "priority" : "low"
  }, {
    "face_count" : 6,
    "name" : "name",
    "description" : "description",
    "id" : 0,
    "priority" : "low"
  } ]
}}]
     - parameter name: (query)  (optional)

     - returns: RequestBuilder<FaceListList> 
     */
    open class func getFaceListsWithRequestBuilder(name: String? = nil) -> RequestBuilder<FaceListList> {
        let path = "/api/v1/facelists"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "name": name
        ])


        let requestBuilder: RequestBuilder<FaceListList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Remove face from the list

     - parameter facelistId: (path)  
     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removeFaceListFace(facelistId: Int, faceId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        removeFaceListFaceWithRequestBuilder(facelistId: facelistId, faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Remove face from the list
     - DELETE /api/v1/facelists/{facelist_id}/faces/{face_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter facelistId: (path)  
     - parameter faceId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func removeFaceListFaceWithRequestBuilder(facelistId: Int, faceId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/facelists/{facelist_id}/faces/{face_id}"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Update face list with provided ID

     - parameter body: (body)  
     - parameter facelistId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateFaceList(body: FaceListUpdate, facelistId: Int, completion: @escaping ((_ data: FaceListGet?,_ error: Error?) -> Void)) {
        updateFaceListWithRequestBuilder(body: body, facelistId: facelistId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update face list with provided ID
     - PUT /api/v1/facelists/{facelist_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "face_count" : 6,
  "name" : "name",
  "description" : "description",
  "id" : 0,
  "priority" : "low"
}}]
     - parameter body: (body)  
     - parameter facelistId: (path)  

     - returns: RequestBuilder<FaceListGet> 
     */
    open class func updateFaceListWithRequestBuilder(body: FaceListUpdate, facelistId: Int) -> RequestBuilder<FaceListGet> {
        var path = "/api/v1/facelists/{facelist_id}"
        let facelistIdPreEscape = "\(facelistId)"
        let facelistIdPostEscape = facelistIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{facelist_id}", with: facelistIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceListGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
